program arrfuncs

  implicit none

  integer, parameter :: rk = kind(1.0d0)
  integer, parameter :: n1 = 2, n2 = 5, n3 = 3
  real(kind=rk) :: a(n1, -1:n2-2, 0:n3-1)
  integer :: n, nsize, klev
  integer :: i, k
  real(kind=rk) :: asum
  real(kind=rk) :: v(size(a))

  character(len=*), parameter :: arr_format = '(I4,'': '',(10F8.4))'
  character(len=*), parameter :: vec_format = '(1X,A,'': '',:,/,(10F8.4))'
  character(len=*), parameter :: ilist_format = '(A,*(I0,:,'', ''))'
  character(len=*), parameter :: flist_format = '(A,*(F8.4,:,'', ''))'

  call random_number(a) ! Returns random numbers between 0 and 1
  a = 2.0_rk * a - 1.0_rk
  n = n1 * n2 * n3
  nsize = size(a)
  write(*,ilist_format) 'n1,n2,n3,n,nsize = ', n1, n2, &
       & n3, n, nsize

  write(*,*) 'values of a , level-by-level :'
  do klev = lbound(a,dim=3), ubound(a,dim=3)
     write(*,arr_format) klev, a(:,:,klev)
  enddo

  !-- Points a .. b
  !TODO: add the needed array intrinsics
  write(*,ilist_format) 'size of a      = '
  write(*,ilist_format) 'shape of a     = '
  write(*,ilist_format) 'dimension of a = '

  !-- Summation over dim=2 using explicit loops:
  !   Loop over all indices "not-dimension-2" -- i.e. ik-index pairs here --
  !   get sum over 2nd dimension ("j-index")
  !   Vector length is a product of all dimensions but dimension 2
  do k = lbound(a,dim=3), ubound(a,dim=3) ! Loop over 3rd dimension
     do i = lbound(a,dim=1), ubound(a,dim=1) ! Loop over 1st dimension
        asum = sum(a(i,:,k))
        write(*,'(A,2(I0,'', ''),F6.4)') 'i,k,asum = ', i, k, asum
     enddo
  enddo

  !TODO: remove comments and implement the same summation as above
  !      using array intrinsics
!  write(*,flist_format) 'sum(a,dim=2) = '


  !-- Points c .. d
  !TODO: remove comments and add missing function calls
!  write(*,ilist_format) 'Local of maximum in a = '
!  write(*,flist_format) 'Minimum value in a = '

  !-- Points e .. h
  !TODO: add the reshape with correct arguments

!  write(*,vec_format) 'values of v', v

  !TODO: add the missing parts
!  write(*,'(A,I0)') 'Number of elements > 0.5 = '
!  write(*,'(A,L1)') 'Are all values >= 0 = '
!  write(*,'(A,L1)') 'Is any value < 0 = '
!  write(*,'(A,I0)') 'Number of negative values = '

end program arrfuncs
