program ex8
  implicit none

  integer, parameter :: dp = selected_real_kind(12)
  real(kind=dp), parameter :: dx = real(0.01,dp), dy = real(0.01,dp)

  ! These variables describe the array
  integer :: nx, ny ! number of rows and columns
  real(kind=dp), dimension(:,:), allocatable :: data
  
  call read_input('bottle.dat')
  call output

contains

  subroutine read_input(filename)
    implicit none

    character(len=*), intent(in) :: filename

    integer, parameter :: funit = 10
    integer :: i, stat
    character(len=2) :: dummy

    !TODO: implement part that reads the input file
 
    ! Set the boundary values after reading the inner region
    data(1:nx,   0     ) = data(1:nx, 1     )
    data(1:nx,     ny+1) = data(1:nx,   ny  )
    data(0,      0:ny+1) = data(1,    0:ny+1)
    data(  nx+1, 0:ny+1) = data(  nx, 0:ny+1)

    close(funit)
  end subroutine read_input

  
  subroutine output
    use, intrinsic :: ISO_C_BINDING
    implicit none

    integer :: stat

    ! Interface for save_png C-function
    interface
       ! The C-function definition is
       !   int save_png(double *data,
       !                const int nx, const int ny,
       !                const char *fname, const char lang)
       function save_png(data, nx, ny, fname, lang) &
            & bind(C,name="save_png") result(stat)
         use, intrinsic :: ISO_C_BINDING
         implicit none
         real(kind=C_DOUBLE) :: data(*)
         integer(kind=C_INT), value, intent(IN) :: nx, ny
         character(kind=C_CHAR), intent(IN) :: fname(*)
         character(kind=C_CHAR), value, intent(IN) :: lang
         integer(kind=C_INT) :: stat
       end function save_png
    end interface

    stat = save_png(data(1:nx, 1:ny), nx, ny, &
         & 'ex8.png' // C_NULL_CHAR, 'F')
    if (stat == 0) write(*,*) 'Output written to ex8.png'
  end subroutine output

end program ex8
